/******************************************
Program : I2C I/O Expander example for Micro128 Using the I2C Utilities 
Company : Micromint, Inc.
*********************************************/
   
#include <mega128.h>    
#include <MMRS485.h>     // Micromints Library for using both USARTs    
#include <stdio.h>      // Standard I/O library  
#include <delay.h>			// Library for delays

      
// Declare your global variables here
unsigned int Pass @0xFFE; 
unsigned char DATA @ 0xFFD;  
unsigned char SLADDR @ 0xFFB;  
int COM;         // if COM = 0 then use USART0 if it = 1 then use USART1 

void(*I2CSEND)(void)=0x0FCBD;  
void(*I2CREAD)(void)=0xFCE2;
void(*I2CINIT100KHZ)(void)=0xFC28;
void(*I2CDisable)(void)=0xFC3C;    
void main(void)
{
// Declare your local variables here

// Set up USART1's Baud rate at 9600 bps with a 11.0592 MHz Crystal
UCSR1A=0x00;      // RX EN, TX EN
UCSR1B=0x18;     // RX EN, TX EN
UCSR1C=0x06;     // 8N1
UBRR1H=0x00;    // Baud rate high - 9600
UBRR1L=0x47;   // Baud rate low 

COM = 1;                           // Use USART1  
DDRD.6 = 0;			   // Make PORTD.6 an output  
PORTD.6 = 1; 			   // Enable the RS485 control line     
printf("Started\r\n");    
while (1)
      {   
      
        (*I2CINIT100KHZ)();
         SLADDR = 0x40;
         DATA = 0xFF;   
         (*I2CSEND)();
         (*I2CDisable)();
         printf("All of the I/O Expanders IO should be high.\r\n"); 
         (*I2CINIT100KHZ)();
         SLADDR = 0x40;   
         (*I2CREAD)();
         (*I2CDisable)();
         printf("The I/O Expanders port = %d\r\n",Pass);
         delay_ms(2000);
         (*I2CINIT100KHZ)();
         SLADDR = 0x40;
         DATA = 0x00;   
         (*I2CSEND)();
         (*I2CDisable)();
         printf("All of the I/O Expanders IO should be low.\r\n");   
         (*I2CINIT100KHZ)();
         SLADDR = 0x40;   
         (*I2CREAD)();
         (*I2CDisable)();
         printf("The I/O Expanders port = %d\r\n",Pass);
         delay_ms(2000);
      
      };
}

